Yate: MimeSdpBody Class Reference

Yate

Public Member Functions | Protected Member Functions | List of all members
MimeSdpBody Class Reference

MIME for application/sdp. More...

`#include <yatemime.h>`

Inheritance diagram for MimeSdpBody:

## Public Member Functions
| MimeSdpBody (bool hashing=false)
| MimeSdpBody (const String &type, const char *buf, int len)
| MimeSdpBody (const MimeHeaderLine &type, const char *buf, int len)
virtual | ~MimeSdpBody ()
virtual void * | getObject (const String &name) const
virtual bool | isSDP () const
virtual MimeBody * | clone () const
const ObjList & | lines () const
unsigned int | hash () const
NamedString * | addLine (const char *name, const char *value=0)
const NamedString * | getLine (const char *name) const
const NamedString * | getNextLine (const NamedString *line) const
Public Member Functions inherited from MimeBody
virtual | ~MimeBody ()
const MimeHeaderLine & | getType () const
MimeBody * | getFirst (const String &type) const
const ObjList & | headers () const
void | appendHdr (MimeHeaderLine *hdr)
void | removeHdr (MimeHeaderLine *hdr, bool delobj=true)
MimeHeaderLine * | findHdr (const String &name, const MimeHeaderLine *start=0) const
void | buildHeaders (String &buf)
bool | setParam (const char *name, const char *value=0, const char *header=0)
bool | delParam (const char *name, const char *header=0)
const NamedString * | getParam (const char *name, const char *header=0) const
const DataBlock & | getBody () const
const DataBlock & | body () const
virtual bool | isMultipart () const
Public Member Functions inherited from GenObject
| GenObject ()
virtual | ~GenObject ()
virtual bool | alive () const
virtual void | destruct ()
virtual const String & | toString () const
virtual const String & | traceId () const
NamedCounter * | getObjCounter () const
NamedCounter * | setObjCounter (NamedCounter *counter)

## Protected Member Functions
| MimeSdpBody (const MimeSdpBody &original)
virtual void | buildBody () const
Protected Member Functions inherited from MimeBody
| MimeBody (const String &type)
| MimeBody (const MimeHeaderLine &type)

## Additional Inherited Members
Static Public Member Functions inherited from MimeBody
static MimeBody * | build (const char *buf, int len, const MimeHeaderLine &type)
static String * | getUnfoldedLine (const char *&buf, int &len)
Static Public Member Functions inherited from GenObject
static void * | getObject (const String &name, const GenObject *obj)
static bool | getObjCounting ()
static void | setObjCounting (bool enable)
static NamedCounter * | getObjCounter (const String &name, bool create=true)
static ObjList & | getObjCounters ()
Protected Attributes inherited from MimeBody
DataBlock | m_body
ObjList | m_headers

## Detailed Description

MIME for application/sdp.

An object holding the lines of an application/sdp MIME type

## Constructor & Destructor Documentation

## ◆ MimeSdpBody() [1/4]

MimeSdpBody | ( | bool | hashing = false | ) |

Default constructor, builds an empty application/sdp

Parameters

  hashing | Enable hashing the content lines

Referenced by MimeSdpBody().

## ◆ MimeSdpBody() [2/4]

MimeSdpBody | ( | const String & | type,
|  | const char * | buf,
|  | int | len )

Constructor from block of data

Parameters

  type | The value of the Content-Type header line
  buf | Pointer to buffer of data
  len | Length of data in buffer

## ◆ MimeSdpBody() [3/4]

MimeSdpBody | ( | const MimeHeaderLine & | type,
|  | const char * | buf,
|  | int | len )

Constructor from block of data

Parameters

  type | The content type header line
  buf | Pointer to buffer of data
  len | Length of data in buffer

## ◆ ~MimeSdpBody()

virtual ~MimeSdpBody | ( |  | ) |
| virtual

Destructor

## ◆ MimeSdpBody() [4/4]

MimeSdpBody | ( | const MimeSdpBody & | original | ) |
| protected

Copy constructor

References MimeSdpBody().

## Member Function Documentation

## ◆ addLine()

NamedString * addLine | ( | const char * | name,
|  | const char * | value = 0 )

Append a new name=value line of SDP data

Parameters

  name | Name of the line, should be one character
  value | Text of the line

Returns
  Pointer to new added line

## ◆ buildBody()

virtual void buildBody | ( |  | ) | const
| protectedvirtual

Override that is called internally to build the binary encoded body

Implements MimeBody.

## ◆ clone()

virtual MimeBody * clone | ( |  | ) | const
| virtual

Duplicate this MIME body

Returns
  Copy of this MIME body - a new MimeSdpBody

Implements MimeBody.

References MimeBody::MimeBody().

## ◆ getLine()

const NamedString * getLine | ( | const char * | name | ) | const

Retrieve the first line matching a name

Parameters

  name | Name of the line to search

Returns
  First instance of the searched name or NULL if none present

## ◆ getNextLine()

const NamedString * getNextLine | ( | const NamedString * | line | ) | const

Retrieve the next line of the same type as the current

Parameters

  line | Current line

Returns
  Next instance of same name or NULL if no more

## ◆ getObject()

virtual void * getObject | ( | const String & | name | ) | const
| virtual

RTTI method, get a pointer to a derived class given the class name

Parameters

  name | Name of the class we are asking for

Returns
  Pointer to the requested class or NULL if this object doesn't implement it

Reimplemented from MimeBody.

## ◆ hash()

unsigned int hash | ( |  | ) | const
| inline

Retrieve the hash of body lines

Returns
  Hash of body, zero if hashing not enabled

## ◆ isSDP()

virtual bool isSDP | ( |  | ) | const
| inlinevirtual

Override that checks if this body is an Session Description Protocol

Returns
  True, since this body holds a SDP

Reimplemented from MimeBody.

## ◆ lines()

const ObjList & lines | ( |  | ) | const
| inline

Retrieve the lines hold in data

Returns
  List of NamedStrings

The documentation for this class was generated from the following file:

- yatemime.h